--       _________ __                 __
--      /   _____//  |_____________ _/  |______     ____  __ __  ______
--      \_____  \\   __\_  __ \__  \\   __\__  \   / ___\|  |  \/  ___/
--      /        \|  |  |  | \// __ \|  |  / __ \_/ /_/  >  |  /\___ \
--     /_______  /|__|  |__|  (____  /__| (____  /\___  /|____//____  >
--             \/                  \/          \//_____/            \/
--  ______________________                           ______________________
--                        T H E   W A R   B E G I N S
--         Stratagus - A free fantasy real time strategy game engine
--
--      (c) Copyright 1998-2015 by Joris Dauphin, Jimmy Salmon, 
--											Kyran Jackson and cybermind
--
--      This program is free software; you can redistribute it and/or modify
--      it under the terms of the GNU General Public License as published by
--      the Free Software Foundation; either version 2 of the License, or
--      (at your option) any later version.
--
--      This program is distributed in the hope that it will be useful,
--      but WITHOUT ANY WARRANTY; without even the implied warranty of
--      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--      GNU General Public License for more details.
--
--      You should have received a copy of the GNU General Public License
--      along with this program; if not, write to the Free Software
--      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--

DefineUnitType("unit-buildpoint-townhall", {})
DefineUnitType("unit-footman", {})
DefineUnitType("unit-archer", {})
DefineUnitType("unit-ballista", {})
DefineUnitType("unit-knight", {})
DefineUnitType("unit-mage", {})
DefineUnitType("unit-paladin", {})
DefineUnitType("unit-nomad", {})
DefineUnitType("unit-yeoman", {})
DefineUnitType("unit-dwarves", {})
DefineUnitType("unit-dragon", {})
DefineUnitType("unit-female-hero", {})
DefineUnitType("unit-ranger", {})
DefineUnitType("unit-sharp-axe", {})
DefineUnitType("unit-grunt", {})
DefineUnitType("unit-gryphon-rider", {})
DefineUnitType("unit-peasant", {})
DefineUnitType("unit-peon", {})
DefineUnitType("unit-axethrower", {})
DefineUnitType("unit-catapult", {})
DefineUnitType("unit-ogre", {})
DefineUnitType("unit-death-knight", {})
DefineUnitType("unit-ogre-mage", {})
DefineUnitType("unit-goblin-sappers", {})
DefineUnitType("unit-berserker", {})
DefineUnitType("unit-arthor-literios", {})
DefineUnitType("unit-quick-blade", {})
DefineUnitType("unit-knight-rider", {})
DefineUnitType("unit-fad-man", {})
DefineUnitType("unit-attack-peasant", {})

Load("mods/thunder/scripts/ai/ai_redribbon_2014.lua")
AiRedRibbon_Setup_Units_2014()

-- Spawn Human Units

DefineSpell("spell-unit-footman",
	"showname", "Footman",
	"res-cost", {0, ftm_cost_gold[1], ftm_cost_wood[1], ftm_cost_oil[1], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
	"action", {
		{"summon", "unit-type", "unit-footman", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect", "start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-yeoman",
	"showname", "Yeoman",
	"res-cost", {0, ftm_cost_gold[12], ftm_cost_wood[12], ftm_cost_oil[12], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-yeoman", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-archer",
	"showname", "Archer",
	"res-cost", {0, ftm_cost_gold[3], ftm_cost_wood[3], ftm_cost_oil[3], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-archer", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-ballista",
	"showname", "Ballista",
	"res-cost", {0, ftm_cost_gold[9], ftm_cost_wood[9], ftm_cost_oil[9], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-ballista", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-knight",
	"showname", "Knight",
	"res-cost", {0, ftm_cost_gold[6], ftm_cost_wood[6], ftm_cost_oil[6], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-knight", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-female-hero",
	"showname", "Hero Archer",
	"res-cost", {0, ftm_cost_gold[5], ftm_cost_wood[5], ftm_cost_oil[5], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-female-hero", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-knight-rider",
	"showname", "Hero Horseman",
	"res-cost", {0, ftm_cost_gold[8], ftm_cost_wood[8], ftm_cost_oil[8], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-knight-rider", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-arthor-literios",
	"showname", "Hero Soldier",
	"res-cost", {0, ftm_cost_gold[2], ftm_cost_wood[2], ftm_cost_oil[2], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-arthor-literios", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-sharp-axe",
	"showname", "Hero Axethrower",
	"res-cost", {0, ftm_cost_gold[55], ftm_cost_wood[55], ftm_cost_oil[55], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-sharp-axe", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-mage",
	"showname", "Mage",
	"res-cost", {0, ftm_cost_gold[14], ftm_cost_wood[14], ftm_cost_oil[14], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-mage", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-paladin",
	"showname", "Paladin",
	"res-cost", {0, ftm_cost_gold[7], ftm_cost_wood[7], ftm_cost_oil[7], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-paladin", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-dwarves",
	"showname", "Dwarves",
	"res-cost", {0, ftm_cost_gold[11], ftm_cost_wood[11], ftm_cost_oil[11], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-dwarves", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-peasant",
	"showname", "Peasant",
	"res-cost", {0, ftm_cost_gold[15], ftm_cost_wood[15], ftm_cost_oil[15], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-peasant", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-ranger",
	"showname", "Ranger",
	"res-cost", {0, ftm_cost_gold[4], ftm_cost_wood[4], ftm_cost_oil[4], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-ranger", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-gryphon-rider",
	"showname", "Gryphon Rider",
	"res-cost", {0, ftm_cost_gold[13], ftm_cost_wood[13], ftm_cost_oil[13], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-gryphon-rider", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-attack-peasant",
	"showname", "Minuteman",
	"res-cost", {0, ftm_cost_gold[10], ftm_cost_wood[10], ftm_cost_oil[10], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-attack-peasant", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

-- Spawn Orc Units

DefineSpell("spell-unit-fad-man",
	"showname", "Hero Horseman",
	"res-cost", {0, ftm_cost_gold[58], ftm_cost_wood[58], ftm_cost_oil[58], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-fad-man", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-peon",
	"showname", "Peon",
	"res-cost", {0, ftm_cost_gold[65], ftm_cost_wood[65], ftm_cost_oil[65], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-peon", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-grunt",
	"showname", "Grunt",
	"res-cost", {0, ftm_cost_gold[51], ftm_cost_wood[51], ftm_cost_oil[51], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-grunt", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-axethrower",
	"showname", "Troll Axethrower",
	"res-cost", {0, ftm_cost_gold[53], ftm_cost_wood[53], ftm_cost_oil[53], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-axethrower", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-catapult",
	"showname", "Catapult",
	"res-cost", {0, ftm_cost_gold[59], ftm_cost_wood[59], ftm_cost_oil[59], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-catapult", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-ogre",
	"showname", "Ogre",
	"res-cost", {0, ftm_cost_gold[56], ftm_cost_wood[56], ftm_cost_oil[56], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-ogre", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-death-knight",
	"showname", "Death Knight",
	"res-cost", {0, ftm_cost_gold[64], ftm_cost_wood[64], ftm_cost_oil[64], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-death-knight", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-ogre-mage",
	"showname", "Ogre Mage",
	"res-cost", {0, ftm_cost_gold[57], ftm_cost_wood[57], ftm_cost_oil[57], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-ogre-mage", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-dragon",
	"showname", "Dragon",
	"res-cost", {0, ftm_cost_gold[63], ftm_cost_wood[63], ftm_cost_oil[63], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-dragon", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-quick-blade",
	"showname", "Hero Soldier",
	"res-cost", {0, ftm_cost_gold[52], ftm_cost_wood[52], ftm_cost_oil[52], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-quick-blade", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-goblin-sappers",
	"showname", "Goblin Sappers",
	"res-cost", {0, ftm_cost_gold[61], ftm_cost_wood[61], ftm_cost_oil[61], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-goblin-sappers", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-berserker",
	"showname", "Berserker",
	"res-cost", {0, ftm_cost_gold[54], ftm_cost_wood[54], ftm_cost_oil[54], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-berserker", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)
--[[
DefineSpell("spell-unit-skeleton",
	"showname", "Skeleton",
	"res-cost", {0, ftm_cost_gold[60], ftm_cost_wood[60], ftm_cost_oil[60], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-skeleton", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-unit-nomad",
	"showname", "Nomad",
	"res-cost", {0, ftm_cost_gold[62], ftm_cost_wood[62], ftm_cost_oil[62], 0, 0, 0, 0, 0, 0},
	"range", 6,
	"target", "position",
		"action", {{"summon", "unit-type", "unit-nomad", "time-to-live", 99000},
		{"spawn-missile", "missile", "missile-magic-effect",
			"start-point", {"base", "target"}}},
	"sound-when-cast", "magic-holy"
)]]

-- Paladin Abilities

DefineSpell("spell-holy-vision",
	"showname", _("Holy Vision"),
	"manacost", 70,
	"range", "infinite",
	"target", "position",
	"action", {
		{"summon", "unit-type", "unit-revealer", "time-to-live", 200},
		{"spawn-missile", "missile", "missile-magic-effect", "start-point", {"base", "target"}}
	},
	"sound-when-cast", "magic-holy"
)

DefineSpell("spell-healing",
	"showname", _("Healing"),
	"manacost", 6,
	"range", 6,
	"target", "unit",
	"action", {
		{"adjust-vitals", "hit-points", 1},
		{"spawn-missile", "missile", "missile-magic-effect", "start-point", {"base", "target"}}
	},
	"condition", {
		"organic", "only",
		"Building", "false",
		"HitPoints", {MaxValuePercent = 100}
	},
	"sound-when-cast", "magic-holy",
	"depend-upgrade", "upgrade-healing",
	"autocast", {"range", 6, "condition", {"alliance", "only", "HitPoints", {MaxValuePercent = 90}}},
	"ai-cast", {"range", 6, "condition", {"alliance", "only", "HitPoints", {MaxValuePercent = 90}}}
)

DefineSpell("spell-exorcism",
	"showname", _("Exorcism"),
	"manacost", 4,
	"range", 10,
	"target", "unit",
	"action", {
		{"adjust-vitals", "hit-points", -1},
		{"spawn-missile", "missile", "missile-magic-effect", "start-point", {"base", "target"}}
	},
	"condition", {
		"isundead", "only",
		"Building", "false", -- any undead buildings?
	},
	"sound-when-cast", "magic-holy",
	"depend-upgrade", "upgrade-exorcism",
	"autocast", {"range", 10, "condition", {"opponent", "only"}},
	"ai-cast", {"range", 10, "condition", {"opponent", "only"}}
)

--  Alchemist Abilities

local function SpellBlizzard(units)
	-- (c) Copyright 2014 by cybermind
	if (table.getn(units) > 1) then
		local p2 = Players[GetUnitVariable(units[1], "Player")]
		local arunits = {}
		local enemy = 2
		local costs = {}
		for i = 2,table.getn(units) do
			costs[i] = 0
			local p1 = Players[GetUnitVariable(units[i], "Player")]
			if (p1.Index == p2.Index or p1:IsAllied(p2)) then
			else
				costs[i] = costs[i] + GetUnitVariable(units[i], "Priority")
				arunits = GetUnitsAroundUnit(units[i], 5, true)
				for j = 1,table.getn(arunits) do
					if (arunits[j] ~= units[1]) then
						local p3 = Players[GetUnitVariable(arunits[j], "Player")]
						if (p3.Index == p2.Index or p3:IsAllied(p2)) then
							costs[i] = costs[i] - GetUnitVariable(arunits[j], "Priority")
						else
							costs[i] = costs[i] + GetUnitVariable(arunits[j], "Priority")
						end
					end
				end
			end
		end
		for i = 3,table.getn(costs) do
			if costs[i] > costs[enemy] then
				enemy = i
			end
		end
		if (costs[enemy] > 20) then
			local x = GetUnitVariable(units[enemy], "PosX")
			local y = GetUnitVariable(units[enemy], "PosY")
			x = x + math.floor(UnitManager:GetSlotUnit(units[enemy]).Type.TileWidth / 2)
			y = y + math.floor(UnitManager:GetSlotUnit(units[enemy]).Type.TileHeight / 2)
			return x, y
		else 
			return -1, -1
		end
	else
		return -1, -1
	end
end

DefineSpell("spell-blizzard",
	"showname", _("blizzard"),
	"manacost", 25,
	"range", 12,
	"repeat-cast",
	"target", "position",
	"action", {{"area-bombardment", "missile", "missile-blizzard",
		 "fields", 5,
		 "shards", 11,
		 "start-offset-x", -128,
		 "start-offset-y", -128}},
	"sound-when-cast", "blizzard",
	"depend-upgrade", "upgrade-blizzard",
	"autocast", {"range", 12, "priority", {"Priority", true}, "combat", "only", "position-autocast", SpellBlizzard},
	"ai-cast", {"range", 12, "priority", {"Priority", true}, "combat", "only", "position-autocast", SpellBlizzard}
)

DefineSpell("spell-flame-shield",
	"showname", _("flame shield"),
	"manacost", 50,
	"range", 6,
	"target", "unit",
	"action", {
		{"spawn-missile", "missile", "missile-flame-shield", "ttl", 600, "damage", 1},
		{"spawn-missile", "missile", "missile-flame-shield", "ttl", 607, "damage", 1},
		{"spawn-missile", "missile", "missile-flame-shield", "ttl", 614, "damage", 1},
		{"spawn-missile", "missile", "missile-flame-shield", "ttl", 621, "damage", 1},
		{"spawn-missile", "missile", "missile-flame-shield", "ttl", 628, "damage", 1}
	},
	"condition", {"Building", "false", "AirUnit", "false"},
	"sound-when-cast", "flame shield",
	"depend-upgrade", "upgrade-flame-shield",
	"autocast", {"range", 6, "attacker", "only", "condition", {"Coward", "false"}}
)

-- Polymorph crashes the game.
DefineSpell("spell-polymorph",
	"showname", _("polymorph"),
	"manacost", 1,
	"range", 10,
	"target", "unit",
	"action", {{"spawn-missile", "missile", "missile-normal-spell",
			"start-point", {"base", "target"}},
			{"polymorph", "new-form", "unit-critter", "player-neutral"}},
	"condition", {"organic", "only"},
	"sound-when-cast", "polymorph",
	"depend-upgrade", "upgrade-polymorph",
	"autocast", {"range", 10, "priority", {"HitPoints", true}, "condition", {"opponent", "only", "HitPoints", {MinValuePercent = 50}}},
	"ai-cast", {"range", 10, "priority", {"HitPoints", true}, "condition", {"opponent", "only", "HitPoints", {MinValuePercent = 50}}}
)

DefineSpell("spell-invisibility",
	"showname", _("invisibility"),
	"manacost", 200,
	"range", 6,
	"target", "unit",
	"action", {{"adjust-variable", {Invisible = 2000}},
		{"spawn-missile", "missile", "missile-normal-spell",
			"start-point", {"base", "target"}}},
	"condition", {
		"Building", "false",
		"Invisible", {MaxValue = 10}},
	"sound-when-cast", "invisibility",
	"depend-upgrade", "upgrade-invisibility",
	"autocast", {"range", 6, "condition", {"AirUnit", "only", "alliance", "only"}},
	"ai-cast", {"range", 6, "combat", "false", "condition", {"LandUnit", "false", "alliance", "only"}}
)

DefineSpell("spell-slow",
	"showname", _("slow"),
	"manacost", 50,
	"range", 10,
	"target", "unit",
	"action", {{"adjust-variable", {Slow = 1000, Haste = 0}},
		{"spawn-missile", "missile", "missile-normal-spell",
			"start-point", {"base", "target"}}},
	"condition", {
		"Building", "false",
		"Slow", {ExactValue = 0}},
	"sound-when-cast", "slow",
	"depend-upgrade", "upgrade-slow",
	"autocast", {"range", 10, "condition", {"Coward", "false", "opponent", "only"}},
	"ai-cast", {"range", 10, "combat", "only", "condition", {"Coward", "false", "opponent", "only"}}
)

DefineSpell("spell-fireball",
	"showname", _("fireball"),
	"manacost", 100,
	"range", 8,
	"target", "position",
	"action", {{"spawn-missile", "missile", "missile-fireball", "damage", 20}},
	"sound-when-cast", "fireball throw",
	"depend-upgrade", "upgrade-fireball",
	"autocast", {"range", 8, "priority", {"Priority", true}, "condition", {"opponent", "only"}, "position-autocast", SpellBlizzard},
	"ai-cast", {"range", 8, "priority", {"Priority", true}, "condition", {"opponent", "only"}, "position-autocast", SpellBlizzard}
)

DefineSpell("spell-suicide-bomber",
	"showname", _("Demolish"), "manacost", 0, "target", "self", "range", 1,
	"action", {{"demolish", "range", 1, "damage", 400},
		{"spawn-missile", "missile", "missile-normal-spell",
			"end-point",   {"base", "caster"}}},
	"sound-when-cast", "explosion",
	"autocast", {"range", 6, "condition", {"opponent", "only"}},
	"ai-cast", {"range", 6, "condition", {"opponent", "only"}}
)